searchNodes=[{"doc":"NLP Experiments With Elixir The Needlepoint library is a collection of NLP functions for Elixir, generally ported from sPacy or NLTK Python libraries.","ref":"Needlepoint.html","title":"Needlepoint","type":"module"},{"doc":"Stem with a given stemmer. Defaults to snowball. Examples iex&gt; Needlepoint . stem ( &quot;sentence&quot; ) &quot;sentenc&quot;","ref":"Needlepoint.html#stem/2","title":"Needlepoint.stem/2","type":"function"},{"doc":"Tokenize with a given tokenizer. Defaults to treebank. Examples iex&gt; Needlepoint . tokenize ( &quot;A sentence of words.&quot; ) [ &quot;A&quot; , &quot;sentence&quot; , &quot;of&quot; , &quot;words&quot; , &quot;.&quot; ]","ref":"Needlepoint.html#tokenize/3","title":"Needlepoint.tokenize/3","type":"function"},{"doc":"A frequency distribution for the outcomes of an experiment. This basically just adds some functions for use with Enum.frequencies Based on the NLTK class which is a subclass of the Counter in Python's collections class, sometimes called a bag or multiset. Examples iex&gt; alias Needlepoint.Probability.FreqDist iex&gt; FreqDist . new ( ) % Needlepoint.Probability.FreqDist { samples : %{ } } iex&gt; FreqDist . new ( &quot;abracadabra&quot; ) % Needlepoint.Probability.FreqDist { samples : %{ &quot;a&quot; =&gt; 5 , &quot;b&quot; =&gt; 2 , &quot;c&quot; =&gt; 1 , &quot;d&quot; =&gt; 1 , &quot;r&quot; =&gt; 2 } } iex&gt; FreqDist . new ( &quot;ABCABC&quot; ) |&gt; FreqDist . elements ( ) |&gt; Enum . sort ( ) |&gt; Enum . join ( ) &quot;AABBCC&quot; iex&gt; FreqDist . new ( &quot;abracadabra&quot; ) |&gt; FreqDist . most_common ( ) [ { &quot;a&quot; , 5 } , { &quot;r&quot; , 2 } , { &quot;b&quot; , 2 } , { &quot;d&quot; , 1 } , { &quot;c&quot; , 1 } ] iex&gt; FreqDist . new ( &quot;abracadabra&quot; ) |&gt; FreqDist . most_common ( 3 ) [ { &quot;a&quot; , 5 } , { &quot;r&quot; , 2 } , { &quot;b&quot; , 2 } ] iex&gt; FreqDist . new ( &quot;abracadabra&quot; ) |&gt; FreqDist . update ( &quot;simsalabim&quot; ) |&gt; FreqDist . most_common ( ) [ { &quot;a&quot; , 7 } , { &quot;b&quot; , 3 } , { &quot;s&quot; , 2 } , { &quot;r&quot; , 2 } , { &quot;m&quot; , 2 } , { &quot;i&quot; , 2 } , { &quot;l&quot; , 1 } , { &quot;d&quot; , 1 } , { &quot;c&quot; , 1 } ] iex&gt; FreqDist . new ( &quot;abracadabra&quot; ) |&gt; FreqDist . subtract ( &quot;aaaaa&quot; ) % Needlepoint.Probability.FreqDist { samples : %{ &quot;a&quot; =&gt; 0 , &quot;b&quot; =&gt; 2 , &quot;c&quot; =&gt; 1 , &quot;d&quot; =&gt; 1 , &quot;r&quot; =&gt; 2 } }","ref":"Needlepoint.Probability.FreqDist.html","title":"Needlepoint.Probability.FreqDist","type":"module"},{"doc":"Return the total number of sample values (&quot;bins&quot;) that have counts greater than zero. Called B in nltk. Examples iex&gt; FreqDist . bins ( FreqDist . new ( %{ &quot;a&quot; =&gt; 0 , &quot;b&quot; =&gt; 1 } ) ) 1","ref":"Needlepoint.Probability.FreqDist.html#bins/1","title":"Needlepoint.Probability.FreqDist.bins/1","type":"function"},{"doc":"Iterate over elements repeating each as many times as its count. Examples iex&gt; FreqDist . new ( &quot;ABCABC&quot; ) |&gt; FreqDist . elements ( ) |&gt; Enum . sort ( ) [ &quot;A&quot; , &quot;A&quot; , &quot;B&quot; , &quot;B&quot; , &quot;C&quot; , &quot;C&quot; ] # Knuth&#39;s example for prime factors of 1836: 2**2 * 3**3 * 17**1 iex&gt; FreqDist . new ( %{ 2 =&gt; 2 , 3 =&gt; 3 , 17 =&gt; 1 } ) |&gt; FreqDist . elements ( ) |&gt; Enum . reduce ( 1 , fn x , acc -&gt; x * acc end ) 1836 Note, if an element's count has been set to zero or is a negative number, elements() will ignore it.","ref":"Needlepoint.Probability.FreqDist.html#elements/1","title":"Needlepoint.Probability.FreqDist.elements/1","type":"function"},{"doc":"Return the frequency of a given sample. The frequency of a sample is defined as the count of that sample divided by the total number of sample outcomes that have been recorded by this FreqDist. The count of a sample is defined as the number of times that sample outcome was recorded by this FreqDist . Frequencies are always real numbers in the range [0, 1] Examples iex&gt; FreqDist . freq ( FreqDist . new ( %{ &quot;a&quot; =&gt; 0 , &quot;b&quot; =&gt; 1 , &quot;c&quot; =&gt; 2 , &quot;d&quot; =&gt; 2 } ) , &quot;z&quot; ) 0.0 iex&gt; FreqDist . freq ( FreqDist . new ( %{ &quot;a&quot; =&gt; 0 , &quot;b&quot; =&gt; 1 , &quot;c&quot; =&gt; 2 , &quot;d&quot; =&gt; 2 } ) , &quot;a&quot; ) 0.0 iex&gt; FreqDist . freq ( FreqDist . new ( %{ &quot;a&quot; =&gt; 0 , &quot;b&quot; =&gt; 1 , &quot;c&quot; =&gt; 2 , &quot;d&quot; =&gt; 2 } ) , &quot;b&quot; ) 0.2","ref":"Needlepoint.Probability.FreqDist.html#freq/2","title":"Needlepoint.Probability.FreqDist.freq/2","type":"function"},{"doc":"Return a list of all samples that occur once (hapax legomena) Examples iex&gt; FreqDist . hapaxes ( FreqDist . new ( %{ &quot;a&quot; =&gt; 0 , &quot;b&quot; =&gt; 1 , &quot;c&quot; =&gt; 2 } ) ) [ &quot;b&quot; ]","ref":"Needlepoint.Probability.FreqDist.html#hapaxes/1","title":"Needlepoint.Probability.FreqDist.hapaxes/1","type":"function"},{"doc":"intersection is the minimum of corresponding counts. Values that only appear in one count are dropped. Examples iex&gt; FreqDist . new ( &quot;abbb&quot; ) |&gt; FreqDist . intersection ( FreqDist . new ( &quot;bcc&quot; ) ) % Needlepoint.Probability.FreqDist { samples : %{ &quot;b&quot; =&gt; 1 } }","ref":"Needlepoint.Probability.FreqDist.html#intersection/2","title":"Needlepoint.Probability.FreqDist.intersection/2","type":"function"},{"doc":"Return the sample with the greatest number of outcomes. If two or more samples have the same number of outcomes, return one of them; which sample is returned is undefined. If no outcomes have occurred in this frequency distribution, return nil. Examples iex&gt; FreqDist . max ( FreqDist . new ( ) ) nil iex&gt; FreqDist . max ( FreqDist . new ( %{ &quot;a&quot; =&gt; 0 , &quot;b&quot; =&gt; 1 , &quot;c&quot; =&gt; 2 } ) ) &quot;c&quot;","ref":"Needlepoint.Probability.FreqDist.html#max/1","title":"Needlepoint.Probability.FreqDist.max/1","type":"function"},{"doc":"List all counts from the most common to the least. Examples iex&gt; alias Needlepoint.Probability.FreqDist Needlepoint.Probability.FreqDist iex&gt; FreqDist . new ( &quot;aabbbcccddddd&quot; ) |&gt; FreqDist . most_common ( ) [ { &quot;d&quot; , 5 } , { &quot;c&quot; , 3 } , { &quot;b&quot; , 3 } , { &quot;a&quot; , 2 } ]","ref":"Needlepoint.Probability.FreqDist.html#most_common/1","title":"Needlepoint.Probability.FreqDist.most_common/1","type":"function"},{"doc":"List n counts from the most common to the least. Examples iex&gt; alias Needlepoint.Probability.FreqDist Needlepoint.Probability.FreqDist iex&gt; FreqDist . new ( &quot;aabbbcccddddd&quot; ) |&gt; FreqDist . most_common ( 1 ) [ { &quot;d&quot; , 5 } ]","ref":"Needlepoint.Probability.FreqDist.html#most_common/2","title":"Needlepoint.Probability.FreqDist.most_common/2","type":"function"},{"doc":"Return the total number of sample outcomes that have been recorded. Examples iex&gt; FreqDist . n ( FreqDist . new ( &quot;aabbccdd&quot; ) ) 8","ref":"Needlepoint.Probability.FreqDist.html#n/1","title":"Needlepoint.Probability.FreqDist.n/1","type":"function"},{"doc":"Make a new empty FreqDict","ref":"Needlepoint.Probability.FreqDist.html#new/0","title":"Needlepoint.Probability.FreqDist.new/0","type":"function"},{"doc":"Make a new FreqDict from a string, list, map or another FreqDist Examples iex&gt; FreqDist . new ( &quot;gallahad&quot; ) % Needlepoint.Probability.FreqDist { samples : %{ &quot;a&quot; =&gt; 3 , &quot;d&quot; =&gt; 1 , &quot;g&quot; =&gt; 1 , &quot;h&quot; =&gt; 1 , &quot;l&quot; =&gt; 2 } } iex&gt; FreqDist . new ( %{ &quot;a&quot; =&gt; 4 , &quot;b&quot; =&gt; 2 } ) % Needlepoint.Probability.FreqDist { samples : %{ &quot;a&quot; =&gt; 4 , &quot;b&quot; =&gt; 2 } } iex&gt; FreqDist . new ( [ &quot;a&quot; , &quot;a&quot; , &quot;a&quot; , &quot;a&quot; , &quot;b&quot; , &quot;b&quot; ] ) % Needlepoint.Probability.FreqDist { samples : %{ &quot;a&quot; =&gt; 4 , &quot;b&quot; =&gt; 2 } }","ref":"Needlepoint.Probability.FreqDist.html#new/1","title":"Needlepoint.Probability.FreqDist.new/1","type":"function"},{"doc":"Return the dictionary mapping r to Nr, the number of samples with frequency r, where Nr &gt; 0. Examples iex&gt; FreqDist . r_nr ( FreqDist . new ( %{ &quot;a&quot; =&gt; 0 , &quot;b&quot; =&gt; 1 , &quot;c&quot; =&gt; 2 , &quot;d&quot; =&gt; 2 } ) ) %{ 0 =&gt; 1 , 1 =&gt; 1 , 2 =&gt; 2 }","ref":"Needlepoint.Probability.FreqDist.html#r_nr/1","title":"Needlepoint.Probability.FreqDist.r_nr/1","type":"function"},{"doc":"Update the FreqDict fd by subtracting values in the samples. Examples iex&gt; FreqDist . new ( &quot;aaabbb&quot; ) |&gt; FreqDist . subtract ( FreqDist . new ( &quot;aba&quot; ) ) % Needlepoint.Probability.FreqDist { samples : %{ &quot;a&quot; =&gt; 1 , &quot;b&quot; =&gt; 2 } }","ref":"Needlepoint.Probability.FreqDist.html#subtract/2","title":"Needlepoint.Probability.FreqDist.subtract/2","type":"function"},{"doc":"union is the maximum of value in either of the input counters. Examples iex&gt; FreqDist . new ( &quot;abbb&quot; ) |&gt; FreqDist . union ( FreqDist . new ( &quot;bcc&quot; ) ) % Needlepoint.Probability.FreqDist { samples : %{ &quot;a&quot; =&gt; 1 , &quot;b&quot; =&gt; 3 , &quot;c&quot; =&gt; 2 } }","ref":"Needlepoint.Probability.FreqDist.html#union/2","title":"Needlepoint.Probability.FreqDist.union/2","type":"function"},{"doc":"Update the FreqDict fd with the new set of samples. Examples iex&gt; alias Needlepoint.Probability.FreqDist Needlepoint.Probability.FreqDist iex&gt; FreqDist . new ( &quot;aaa&quot; ) |&gt; FreqDist . update ( &quot;bbb&quot; ) % Needlepoint.Probability.FreqDist { samples : %{ &quot;a&quot; =&gt; 3 , &quot;b&quot; =&gt; 3 } }","ref":"Needlepoint.Probability.FreqDist.html#update/2","title":"Needlepoint.Probability.FreqDist.update/2","type":"function"},{"doc":"","ref":"Needlepoint.Probability.FreqDist.html#t:t/0","title":"Needlepoint.Probability.FreqDist.t/0","type":"type"},{"doc":"An imeplemntation of VADER rule based sentiment analysis, based on the NLTK port. Hutto, C.J. &amp; Gilbert, E.E. (2014). VADER: A Parsimonious Rule-based Model for Sentiment Analysis of Social Media Text. Eighth International Conference on Weblogs and Social Media (ICWSM-14). Ann Arbor, MI, June 2014.","ref":"Needlepoint.Sentiment.Vader.html","title":"Needlepoint.Sentiment.Vader","type":"module"},{"doc":"Return a float for sentiment strength based on the input text. Positive values are positive valence, negative value are negative valence. Examples iex&gt; Vader . polarity_scores ( &quot;Shut the hell up!&quot; ) %{ compound : - 0.7088 , neg : 0.62 , neu : 0.38 , pos : 0.0 } iex&gt; Vader . polarity_scores ( &quot;Yes, please.&quot; ) %{ compound : 0.6124 , neg : 0.0 , neu : 0.0 , pos : 1.0 }","ref":"Needlepoint.Sentiment.Vader.html#polarity_scores/1","title":"Needlepoint.Sentiment.Vader.polarity_scores/1","type":"function"},{"doc":"A port of the NLTK version of the snowball stemmer, as described at http://snowball.tartarus.org/algorithms/english/stemmer.html If calling this directly instead of from Needlepoint.stem the word given to stem should be lowercased or else special word and stop words will be stemmed instead of returned.","ref":"Needlepoint.Stem.SnowballStemmer.html","title":"Needlepoint.Stem.SnowballStemmer","type":"module"},{"doc":"Stem the word with the snowball stemmer. Currently there is no option to ignore stopwords like the nltk version. Examples iex&gt; alias Needlepoint.Stem.SnowballStemmer iex&gt; SnowballStemmer . stem ( &quot;running&quot; ) &quot;run&quot; iex&gt; SnowballStemmer . stem ( &quot;abeyance&quot; ) &quot;abey&quot;","ref":"Needlepoint.Stem.SnowballStemmer.html#stem/1","title":"Needlepoint.Stem.SnowballStemmer.stem/1","type":"function"},{"doc":"A processing interface for removing morphological affixes from words. This process is known as stemming.","ref":"Needlepoint.Stemmer.html","title":"Needlepoint.Stemmer","type":"behaviour"},{"doc":"","ref":"Needlepoint.Stemmer.html#c:stem/1","title":"Needlepoint.Stemmer.stem/1","type":"callback"},{"doc":"","ref":"Needlepoint.Stopwords.html","title":"Needlepoint.Stopwords","type":"module"},{"doc":"","ref":"Needlepoint.Stopwords.html#words/1","title":"Needlepoint.Stopwords.words/1","type":"function"},{"doc":"The behaviour for tokenizing. Tokenization is taking a string and breaking it into pieces ( tokens )","ref":"Needlepoint.Tokenizer.html","title":"Needlepoint.Tokenizer","type":"behaviour"},{"doc":"","ref":"Needlepoint.Tokenizer.html#c:tokenize/2","title":"Needlepoint.Tokenizer.tokenize/2","type":"callback"},{"doc":"A simple tokenizer that just splits the input with String.split","ref":"Needlepoint.Tokenizer.Simple.html","title":"Needlepoint.Tokenizer.Simple","type":"module"},{"doc":"A port of the NLTK Treebank Tokenizer Examples iex(1)&gt; alias Needlepoint.Tokenizer.Treebank Needlepoint.Tokenizer.Treebank iex(2)&gt; Treebank . tokenize ( &quot;Good muffins cost $3.88 in New York. Please buy me two of them. Thanks.&quot; ) [ &quot;Good&quot; , &quot;muffins&quot; , &quot;cost&quot; , &quot;$&quot; , &quot;3.88&quot; , &quot;in&quot; , &quot;New&quot; , &quot;York.&quot; , &quot;Please&quot; , &quot;buy&quot; , &quot;me&quot; , &quot;two&quot; , &quot;of&quot; , &quot;them.&quot; , &quot;Thanks&quot; , &quot;.&quot; ] iex(3)&gt; Treebank . tokenize ( &quot;They&#39;ll save and invest more.&quot; ) [ &quot;They&quot; , &quot;&#39;ll&quot; , &quot;save&quot; , &quot;and&quot; , &quot;invest&quot; , &quot;more&quot; , &quot;.&quot; ] iex(4)&gt; Treebank . tokenize ( &quot;hi, my name can&#39;t hello,&quot; ) [ &quot;hi&quot; , &quot;,&quot; , &quot;my&quot; , &quot;name&quot; , &quot;ca&quot; , &quot;n&#39;t&quot; , &quot;hello&quot; , &quot;,&quot; ]","ref":"Needlepoint.Tokenizer.Treebank.html","title":"Needlepoint.Tokenizer.Treebank","type":"module"},{"doc":"","ref":"Needlepoint.Util.html","title":"Needlepoint.Util","type":"module"},{"doc":"Check if a string is downcased. Examples iex&gt; Needlepoint.Util . is_downcase? ( &quot;foo&quot; ) true iex&gt; Needlepoint.Util . is_downcase? ( &quot;FOo&quot; ) false iex&gt; Needlepoint.Util . is_downcase? ( &quot;FOO&quot; ) false iex&gt; Needlepoint.Util . is_downcase? ( &quot;:)&quot; ) true","ref":"Needlepoint.Util.html#is_downcase?/1","title":"Needlepoint.Util.is_downcase?/1","type":"function"},{"doc":"Check if a string is uppercased. Examples iex&gt; Needlepoint.Util . is_upcase? ( &quot;foo&quot; ) false iex&gt; Needlepoint.Util . is_upcase? ( &quot;FOo&quot; ) false iex&gt; Needlepoint.Util . is_upcase? ( &quot;FOO&quot; ) true iex&gt; Needlepoint.Util . is_upcase? ( &quot;:D&quot; ) true","ref":"Needlepoint.Util.html#is_upcase?/1","title":"Needlepoint.Util.is_upcase?/1","type":"function"},{"doc":"Return the ngrams generated from a sequence of items, as a stream. Examples iex&gt; Needlepoint.Util . ngrams ( [ 1 , 2 , 3 , 4 , 5 ] , 3 ) |&gt; Enum . to_list ( ) [ [ 1 , 2 , 3 ] , [ 2 , 3 , 4 ] , [ 3 , 4 , 5 ] ] iex&gt; Needlepoint.Util . ngrams ( [ 1 , 2 , 3 , 4 , 5 ] , 2 , pad_right : true ) |&gt; Enum . to_list ( ) [ [ 1 , 2 ] , [ 2 , 3 ] , [ 3 , 4 ] , [ 4 , 5 ] , [ 5 , nil ] ] iex&gt; Needlepoint.Util . ngrams ( [ 1 , 2 , 3 , 4 , 5 ] , 2 , pad_right : true , right_pad_symbol : &quot;&lt;/s&gt;&quot; ) |&gt; Enum . to_list ( ) [ [ 1 , 2 ] , [ 2 , 3 ] , [ 3 , 4 ] , [ 4 , 5 ] , [ 5 , &quot;&lt;/s&gt;&quot; ] ] iex&gt; Needlepoint.Util . ngrams ( [ 1 , 2 , 3 , 4 , 5 ] , 2 , pad_left : true , left_pad_symbol : &quot;&lt;s&gt;&quot; ) |&gt; Enum . to_list ( ) [ [ &quot;&lt;s&gt;&quot; , 1 ] , [ 1 , 2 ] , [ 2 , 3 ] , [ 3 , 4 ] , [ 4 , 5 ] ] iex&gt; Needlepoint.Util . ngrams ( [ 1 , 2 , 3 , 4 , 5 ] , 2 , pad_left : true , pad_right : true , left_pad_symbol : &quot;&lt;s&gt;&quot; , right_pad_symbol : &quot;&lt;/s&gt;&quot; ) |&gt; Enum . to_list ( ) [ [ &quot;&lt;s&gt;&quot; , 1 ] , [ 1 , 2 ] , [ 2 , 3 ] , [ 3 , 4 ] , [ 4 , 5 ] , [ 5 , &quot;&lt;/s&gt;&quot; ] ]","ref":"Needlepoint.Util.html#ngrams/2","title":"Needlepoint.Util.ngrams/2","type":"function"},{"doc":"","ref":"Needlepoint.Util.html#ngrams/3","title":"Needlepoint.Util.ngrams/3","type":"function"},{"doc":"Returns a padded sequence of items before ngram extraction. Examples iex&gt; alias Needlepoint.Util Needlepoint.Util iex&gt; Util . pad_sequence ( [ 1 , 2 , 3 , 4 , 5 ] , 2 ) [ 1 , 2 , 3 , 4 , 5 ] iex&gt; Util . pad_sequence ( [ 2 , 3 , 4 , 5 , 6 ] , 3 , pad_left : true , pad_right : true ) [ nil , nil , 2 , 3 , 4 , 5 , 6 , nil , nil ] iex&gt; Util . pad_sequence ( [ 3 , 4 , 5 , 6 , 7 ] , 2 , pad_left : true , pad_right : true , left_pad_symbol : &quot;&lt;s&gt;&quot; , right_pad_symbol : &quot;&lt;/s&gt;&quot; ) [ &quot;&lt;s&gt;&quot; , 3 , 4 , 5 , 6 , 7 , &quot;&lt;/s&gt;&quot; ] iex&gt; Util . pad_sequence ( [ 4 , 5 , 6 , 7 , 8 ] , 2 , pad_left : true , left_pad_symbol : &quot;&lt;s&gt;&quot; ) [ &quot;&lt;s&gt;&quot; , 4 , 5 , 6 , 7 , 8 ] iex&gt; Util . pad_sequence ( [ 5 , 6 , 7 , 8 , 9 ] , 2 , pad_right : true , right_pad_symbol : &quot;&lt;/s&gt;&quot; ) [ 5 , 6 , 7 , 8 , 9 , &quot;&lt;/s&gt;&quot; ]","ref":"Needlepoint.Util.html#pad_sequence/2","title":"Needlepoint.Util.pad_sequence/2","type":"function"},{"doc":"","ref":"Needlepoint.Util.html#pad_sequence/3","title":"Needlepoint.Util.pad_sequence/3","type":"function"},{"doc":"Take the product of 2 enumerables, a simple version of Python's itertools.product Examples iex&gt; Needlepoint.Util . product ( [ ] , [ ] ) [ ] iex&gt; Needlepoint.Util . product ( [ &quot;a&quot; , &quot;b&quot; ] , [ &quot;x&quot; , &quot;y&quot; , &quot;z&quot; ] ) [ [ &quot;a&quot; , &quot;x&quot; ] , [ &quot;a&quot; , &quot;y&quot; ] , [ &quot;a&quot; , &quot;z&quot; ] , [ &quot;b&quot; , &quot;x&quot; ] , [ &quot;b&quot; , &quot;y&quot; ] , [ &quot;b&quot; , &quot;z&quot; ] ]","ref":"Needlepoint.Util.html#product/2","title":"Needlepoint.Util.product/2","type":"function"},{"doc":"Some NLP Algorithms in Elixir. Currently available: A Port of NTLK's FreqDist class Snowball Stemmer Treebank Tokenizer VADER Sentiment Analysis","ref":"readme.html","title":"Needlepoint","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding needlepoint to your list of dependencies in mix.exs : def deps do [ { :needlepoint , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Needlepoint - Installation","type":"extras"}]